%define releasebase 1
# Requires " easy_install -U Sphinx" Do not use pythoing-sphinx rpm

#Use as deafults if no command line inputs
%define as_limulus 1
# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif
%define modulepath /opt/Modules/modulefiles
%define modulename julia
%define prefix /opt/%{name}/%{version}
%define devtoolsetpath /opt/rh/devtoolset-2
%define llvmlib libLLVM-3.3.so
Summary: The Julia technical computing language
Name: julia 
Version:0.3.6
License: GPL and those of respective owners
Group: %{targetbase}/Benchmarking
Release: %{releasebase}.%{targetbase}
Source: %{name}-%{version}.tar.gz
URL: julialang.org
Vendor: Basement Supercomputing
Packager: deadline@basement-supercomputing.com
%define ver %{version}-%{release}
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Source1: JuliaLanguage.pdf
%description
Julia is a high-level, high-performance dynamic programming language for technical computing, with syntax that is familiar to users of other technical computing environments. It provides a sophisticated compiler, distributed parallel execution, numerical accuracy, and an extensive mathematical function library. The library, largely written in Julia itself, also integrates mature, best-of-breed C and Fortran libraries for linear algebra, random number generation, signal processing, and string processing.

%prep 
%setup -n %{name}
%build
. %{devtoolsetpath}/enable
%{?scl:scl enable %scl - << \EOF}

make
%{?scl:EOF}

cd doc
make html
make man
# Cannot built the pdf on RH6, for now use the prebuildt version, which is
# included as %SOURCE1
#make latexpdf

%install

# create /opt//etc/ld.so.conf.d/
echo "Creating /opt/etc/ld.so.conf.d/%{name} file"
mkdir -p %{buildroot}/opt/etc/ld.so.conf.d
cat <<EOF> %{buildroot}/opt/etc/ld.so.conf.d/%{name}-%{version}.conf
%{prefix}/lib/julia
EOF

#create the module file
echo "Creating module file"
mkdir -p %{buildroot}/%{modulepath}/%{modulename}

cat <<EOF >%{buildroot}/%{modulepath}/%{modulename}/%{version}
#%Module1.0#######################################################################
## %{modulename}  modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing %{name} Version %{version} \n"
}

module-whatis %{name}
module-log error none

set currentmod \$env(HOME)/.currentmodules
set currentstring "module load julia"

if [ module-info mode load ] {
        prepend-path  LD_LIBRARY_PATH %{prefix}/lib/julia
        prepend-path PATH %{prefix}/bin
        append-path MANPATH %{prefix}/doc/man
}
if [ module-info mode remove ] {
        remove-path LD_LIBRARY_PATH %{prefix}/lib/julia
        remove-path PATH %{prefix}/bin
        remove-path MANPATH  %{prefix}/doc/man
}
EOF

JULIA_COMMIT=`git rev-parse --short=10 HEAD`
. %{devtoolsetpath}/enable
%{?scl:scl enable %scl - << \EOF}
make install
%{?scl:EOF}

/bin/mkdir -p  %{buildroot}/%{prefix}
/bin/cp -R julia-$JULIA_COMMIT/*  %{buildroot}/%{prefix}/
# not sure why, but this did not get installed
/bin/cp usr/lib/%{llvmlib} %{buildroot}/%{prefix}/lib/julia/
# put some docs near the top level
/bin/mkdir -p  %{buildroot}/%{prefix}/doc
/bin/mkdir -p  %{buildroot}/%{prefix}/doc/pdf
/bin/mkdir -p  %{buildroot}/%{prefix}/doc/man/man1
/bin/cp doc/_build/html  -R  %{buildroot}/%{prefix}/doc/
/bin/cp doc/_build/man/*.1  -R   %{buildroot}/%{prefix}/doc/man/man1
/bin/cp doc/*.jl  -R  %{buildroot}/%{prefix}/doc/
/bin/cp  %SOURCE1 %{buildroot}/%{prefix}/doc/pdf/
%post
/sbin/ldconfig 2>/dev/null
%postun 
/sbin/ldconfig 2>/dev/null
%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%{prefix}
%{modulepath}/%{modulename}/%{version}
/opt/%{_sysconfdir}/ld.so.conf.d/%{name}-%{version}.conf

%doc CONTRIBUTING.md  LICENSE.md  README.md 

